public final class world{
    /*propertie
    _____________________________*/
    //constant
    int atomQty,
        maxAtom;
    double surfBounce = 0.40d;
    double surfFriction = 0.90d;
    vector boxPos = new vector(400,70),
           boxSize = new vector(340,470),
           gravity = new vector(0,40000);

    //var
    atom atomLst[];
    
    static vectorFunc v = new vectorFunc();
    /*constructor
    _________________________________*/
    public world(int max)
    {
        atomQty = 0;
        maxAtom = max;
        atomLst = new atom[max];
    }
    
    public world(int max, vector pos, vector size)
    {
        atomQty = 0;
        maxAtom = max;
        atomLst = new atom[max];
        boxPos = pos;
        boxSize = size;
    }
    
    public world(world old)
    {
        atomQty = 0;
        maxAtom = old.maxAtom;
        surfBounce = old.surfBounce;
        surfFriction= old.surfFriction;
        boxPos = old.boxPos;
        boxSize = old.boxSize;
        gravity = old.gravity;
        atomLst = new atom[maxAtom];
    }
    

    
    /*method
    _______________________________________*/
    
    public void append(atom nuatom)
    {
        if (atomQty < maxAtom)
            atomLst[atomQty++] = nuatom;
    }
    
    public void resetForce()    // reset force accumulator
    {
        for (int i=0;i<atomQty;i++)
        {
            atomLst[i].zeroforce();
        }
    }
    
    public void interAtomCollisionResponse()
    {
        for (int i=0;i<atomQty;i++)
        {
            ///boolean istate = a.getrest(nuAtom);              //restingcode
            for (int j=0; j<atomQty; j++)
            {
                if (i!=j)
                {
                    ///boolean jstate = a.getrest(olWorld.atomLst[j]);          //restingcode
                    
                    ///if ((istate == false && jstate == false) || (istate == true && jstate == false))            //restingcode
                    {
                        vector link = v.sub(atomLst[i].getpos(), atomLst[j].getpos());     // get direction vector
                        double distCentersSQ = v.magSQ(link);                                    // get SQ distance, 
                        double restlenght = atomLst[i].sizes(atomLst[j]);     // get collision threshold

                        if (distCentersSQ == 0.0d)                                               // check if position overlap
                        {
                            //System.out.println("centers distance: "+ distCentersSQ +" , restlenght:" + restlenght);    // <---- BROKEN, WHY????
                            atomLst[i].addforce(atomLst[i].separate());
                            ///nuAtom = a.unrest(nuAtom);                                        //restingcode
                        }
                        else if (distCentersSQ < restlenght*restlenght)                          // check if collide
                        {
                            //System.out.println("distance from centers: "+ distCentersSQ + " , rest:" + restlenght);    // <---- BROKEN, WHY????
                            atomLst[i].addforce(atomLst[i].repulse(atomLst[j], restlenght, distCentersSQ));
                            ///nuAtom = a.unrest(nuAtom);                                       //restingcode
                        }
                    } 
                }
            }
        }
    }
    
    public void boxCollisionDetectionResponse()
    {
        for (int i=0;i<atomQty;i++)
        {
            atomLst[i].hardcollision(boxSize, boxPos, surfBounce, surfFriction);
            atomLst[i].terminalvelocity();
            atomLst[i].velocitydrag();
            atomLst[i].restingTest();
        }
    }
    
    public void environmentalForce()
    {
        for (int i=0;i<atomQty;i++)
        { 
            atomLst[i].gravity(gravity);
            atomLst[i].terminalforces();
            //wind
            //etc
        }
    }
    
    public void integrate(double deltaT)
    {
        for (int i=0;i<atomQty;i++)
        {
            ///if (a.getrest(olWorld.atomLst[i]) == false)         //restingcode integrate if not at rest
            //{
            atomLst[i].integrate(deltaT);
            //}
            ///else
            //{
            ///    nuWorld.append(olWorld.atomLst[i]);             //restingcode just copy if at rest
            //}
        }
    }
    
    
    
};
